package be.iminds.ilabt.jfed.rspec.generator;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.List;

/**
 * RSpecGenerator
 */
public interface RSpecGenerator {
    /**
     * @param am AM URN, server ID or testbed ID (auto detected)
     */
    void setAm(@Nonnull String am);
    void setNodeCount(int nodeCount);
    void setNodeNames(@Nonnull List<String> nodeNames);
    void setNodePrefix(@Nullable String prefix);
    void setResourceClassIdPrefix(@Nullable String rcIdPrefix);
    void setNodeAnsibleGroup(@Nonnull List<String> nodeAnsibleGroup);
    void setDiskImage(@Nullable String diskImage);
    void setLink(@Nullable Boolean link);
    void setLinkSubnet(@Nullable String linkSubnet);
    void setLinkStartIpIndex(@Nullable Integer linkStartIpIndex);

    @Nonnull String generateRequest();
}
